#ifdef __USE_CMSIS
#include "LPC17xx.h"
#endif

.section .text,"ax"
.cpu cortex-m3
.thumb
.syntax unified

.global funcexo1
.global funcexo2
.global funcexo3
.global majuscule

/*****************************************************
 * function     : exercice1
 * R0: A pointer
 * R1: B pointer
 * return value : *A + *B
 *****************************************************/
.thumb_func
funcexo1:
	ldr r2, [r0]
	ldr r3, [r1]
	adds r2, r3
	bhs add_err
	mov r0, r2
	bx lr

add_err:
	mov r0, #0
	bx  lr


/*****************************************************
 * function     : exercice2
 * R0: A pointer
 * R1: B pointer
 * R2: arrays size
 * return value : B[]=2*A[]
 *****************************************************/
.thumb_func
funcexo2:
	// r3 index for loop
	mov r3, #1
	cmp r3, r2
	blt funcexo2_for_loop


funcexo2_for_loop:
	add r3, #1
	ldr r4, [r0], #4
	adds r4, r4
	bhs err
	str r4, [r1], #4
	cmp r3, r2
	blo funcexo2_for_loop
	mov r0, #1
	bx	lr

err:
	mov r0, #0
	bx  lr



.thumb_func
majuscule:
	//index tableau
	mov r1, #0

boucle_while:
	ldrb r2, [r0, r1]
	cmp r2, #0
	beq exit
	cmp r2, #97
	blt next_iter
	cmp r2, #122
	bgt next_iter
	sub r2, #32
	strb r2, [r0, r1]
	b next_iter

next_iter:
	add r1, #1
	b boucle_while

exit:
	bx lr

/*majuscule:
	//index while loop
	mov r1, #0

debut_while:
	ldrb r2, [r0]
	cmp r2, #0
	bne funcexo3_while_loop
	bx lr

funcexo3_while_loop:
	cmp r2, #97
	bge second_cond
	bx lr

second_cond:
	cmp r2, #122
	ble if_cond
	bx lr

if_cond:
	sub r2, #32
	strb r2, [r0], #1
	add r1, #1
	b debut_while*/


//.weak add_sat
.ltorg
